#pragma once

#include <Irrlicht.h>
#include <IMeshLoader.h>
#include <SAnimatedMesh.h> 
#include <SMesh.h> 
#include <SSkinMeshBuffer.h> 
#include <vector>
#include "clsPMDFile.h"
#include "clsVMDFile.h"

#include "PMDMaterial.h"

using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

class CPMDFileLoader : public IMeshLoader
{
public:
    CPMDFileLoader(void);
    CPMDFileLoader(irr::video::IVideoDriver *dri);
    ~CPMDFileLoader(void);

    // IMeshLoaderKv2̊֐
    IAnimatedMesh *  createMesh (io::IReadFile *file);
    bool isALoadableFileExtension (const c8 *fileName) const;

    int materialCount;

protected:
    // hCoBeNX`ǂݍݓɎgp
    irr::video::IVideoDriver *driver;
    
    // }eAIuWFNg
    std::vector<CPMDMaterial*> vecPMDMaterial;

    // bVFIuWFNgЂƂ܂Ƃ߂
    SMesh *smesh;

    // Aj[VbV
    // bV񂩂Aj[VbV쐬
    SAnimatedMesh *samesh;

    // PMDf[^p
    clsPMDFile *pmd;
    clsVMDFile *vmd;

    // o֐
    void createMaterialData();
    void init();
    void release();
};
