
#include "common.h"
#include "MMD_IO.h"
#include "clsCSVFile.h"

void PARSE_LINE::Import( const vector<string>&_fields ) 
{
	fields = _fields;
}
void PARSE_LINE::Export( vector<string>&_fields ) const
{
	_fields = fields;
}
const string PARSE_LINE::ToText()
{
	string text;
	fields >> text;
	return text;
}

clsCSVFile::clsCSVFile(void)
{
}

clsCSVFile::~clsCSVFile(void)
{
}

BOOL clsCSVFile::Open(const string&name )
{
	FIELDS fields;
	string text;
	fstream fs;
	fs.open( name.c_str(),ios::in,_SH_SECURE );
	if ( fs.bad() || fs.fail() )
		return FALSE;

	while ( !fs.eof() ){
		getline( fs,text );
		NEW_FIELD(fields);
		fields << text;
		AddFields( fields );
	}
	fs.close();
	return TRUE;
}
BOOL clsCSVFile::Commit(const string&name )
{
	fstream fs;
	fs.open( name.c_str(),ios::out,_SH_SECURE );
	if ( fs.bad() || fs.fail() )
		return FALSE;

	for ( PARSE_LINE_BUFFER::size_type i=0;i<m_csv.size();i++ ){
		fs << m_csv[i].ToText() << endl;
	}
	fs.close();
	return TRUE;
}

PARSE_LINE_BUFFER& clsCSVFile::GetBuffer()
{
	return m_csv;
}
void clsCSVFile::AddFields( const vector<string>& fields ) 
{
	PARSE_LINE line;
	line.Import( fields );
	m_csv.push_back( line );
}

