#pragma once

//#include "BoneNode.h"
#pragma warning( disable:4530 )

#pragma pack(1)
	struct PMD_HEADER {
		PMD_HEADER(){
			memset(header1,0xFD,sizeof(header1));
			memset(header2,0xFD,sizeof(header2));
		}
		char header1[0x1b];
		char header2[0x100];
	};
	struct PMD_VERTEX_RECORD {
		float x;	// W
		float y;
		float z;
		float nx;	// @xNg
		float ny;	
		float nz;
		float tx;	// eNX`UV
		float ty;
		WORD  b1;	// {[1
		WORD  b2;	// {[2
		BYTE  bw;	// EFCg
		BYTE  unknown;	// GbW
	};
	struct PMD_INDEX_RECORD {
		WORD  id;	// _ԍ
	};
	struct PMD_MATERIAL_RECORD {	// }eA
		struct { 
			float r;
			float g;
			float b;
			float a;
		} diffuse;
		float shininess;
		struct { 
			float r;
			float g;
			float b;
		} specular, ambient;
		WORD p12;
		DWORD nEdges;
		char textureFileName[20]; 
	};
	struct PMD_BONE_RECORD {
		char  name[20];
		WORD  parent;
		WORD  to;
		BYTE  kind;
		WORD  knum;
		float pos[3];
	};
	struct PMD_IK_RECORD {
		void Read(istream &is) {
			is.read( (char*)&parent,sizeof(parent) );
			is.read( (char*)&to,sizeof(to) );
			is.read( (char*)&num_link,sizeof(num_link) );
			is.read( (char*)&count,sizeof(count) );
			is.read( (char*)&fact,sizeof(fact) );
			link.resize(num_link);
			is.read( (char*)&link[0],num_link*sizeof(WORD) );
		};
		void Write(ostream &os) {
			os.write( (char*)&parent,sizeof(parent) );
			os.write( (char*)&to,sizeof(to) );
			os.write( (char*)&num_link,sizeof(num_link) );
			os.write( (char*)&count,sizeof(count) );
			os.write( (char*)&fact,sizeof(fact) );
			os.write( (char*)&link[0],num_link*sizeof(WORD) );
		};
		WORD  parent;
		WORD  to;
		BYTE  num_link;
		WORD  count;
		float fact;
		vector<WORD>link;
	};
	struct PMD_MORP_VERTEX_RECORD {
		int no;
		float vec[3];
	};

	struct PMD_MORP_RECORD {
		void Read(istream &is) {
			is.read( name,sizeof(name) );
			is.read( (char*)&vnum,sizeof(vnum) );
			is.read( (char*)&grp,sizeof(grp) );
			mv.resize(vnum);
			is.read( (char*)&mv[0],vnum*sizeof(PMD_MORP_VERTEX_RECORD) );
		}
		void Write(ostream &os) {
			os.write( name,sizeof(name) );
			os.write( (char*)&vnum,sizeof(vnum) );
			os.write( (char*)&grp,sizeof(grp) );
			os.write( (char*)&mv[0],vnum*sizeof(PMD_MORP_VERTEX_RECORD) ); 
		}
		char  name[20];
		DWORD vnum;
		BYTE grp;
		vector<PMD_MORP_VERTEX_RECORD>mv;
	};
	
	struct PMD_GRP_NAME_RECORD {
		char name[50];
	};

	struct PMD_GRP_RECORD {
		WORD bone_no;
		BYTE grp;
	};

/*
	struct PMD_MORP_RECORD {
		void Read(istream &is) {
			is.read( (char*)&nnum,sizeof(nnum) );
			mt.resize( nnum );
			for (int i=0;i<nnum;i++){
				mt[i].Read( is );
			}
		};
		void Write(ostream &os) {
			os.write( (char*)&nnum,sizeof(nnum) );
			for (int i=0;i<nnum;i++){
				mt[i].Write( os );
			}
		};
		WORD nnum;
		vector<PMD_MORP_TARGET_RECORD>mt;
	};
*/

#pragma pack(8)

typedef vector<PMD_VERTEX_RECORD>   PMD_VERTEX_CHUNK;
typedef vector<WORD>			    PMD_INDEX_CHUNK;
typedef vector<PMD_MATERIAL_RECORD> PMD_MATERIAL_CHUNK;
typedef vector<PMD_BONE_RECORD>     PMD_BONE_CHUNK;
typedef vector<PMD_IK_RECORD>		PMD_IK_CHUNK;
typedef vector<PMD_MORP_RECORD>     PMD_MORP_CHUNK;
typedef vector<WORD>			    PMD_CTRL_CHUNK;
typedef vector<PMD_GRP_NAME_RECORD>	PMD_GRP_NAME_CHUNK;
typedef vector<PMD_GRP_RECORD>      PMD_GRP_CHUNK;


class clsPMDFile
{
public:
	clsPMDFile(void);
	~clsPMDFile(void);

	BOOL Open(const char* name);
	BOOL Commit(const char* name);

	int		GetVersion();
	void	SetVersion(int ver);

	const char* GetHeaderString();
	void	SetHeaderString(const char* name);

	const char*	GetActor();
	void	SetActor(const char* name );

	int		GetVertexChunkSize();
	void	SetVertexChunkSize(int size);
	PMD_VERTEX_CHUNK& GetVertexChunk();

	int		GetIndexChunkSize();
	void	SetIndexChunkSize(int size);
	PMD_INDEX_CHUNK& GetIndexChunk();

	int		GetBoneChunkSize();
	void	SetBoneChunkSize(int size);
	PMD_BONE_CHUNK& GetBoneChunk();

	int		GetIKChunkSize();
	void	SetIKChunkSize(int size);
	PMD_IK_CHUNK& GetIKChunk();

	int		GetMaterialChunkSize();
	void	SetMaterialChunkSize(int size);
	PMD_MATERIAL_CHUNK& GetMaterialChunk();

	int		GetMorpChunkSize();
	void	SetMorpChunkSize(int size);
	PMD_MORP_CHUNK& GetMorpChunk();

	int		GetCtrlChunkSize();
	void	SetCtrlChunkSize(int size);
	PMD_CTRL_CHUNK& GetCtrlChunk();

	int		GetGrpNameChunkSize();
	void	SetGrpNameChunkSize(int size);
	PMD_GRP_NAME_CHUNK& GetGrpNameChunk();

	int		GetGrpChunkSize();
	void	SetGrpChunkSize(int size);
	PMD_GRP_CHUNK& GetGrpChunk();

public:
//	BoneNode* m_bone_node;
//	map<string,BoneNode*> m_bone_map;
//	vector<BoneNode*> m_bone_array;

	PMD_HEADER			m_header;
	PMD_VERTEX_CHUNK	m_vertexs;
	PMD_INDEX_CHUNK		m_indexs;
	PMD_MATERIAL_CHUNK	m_materials;
	PMD_BONE_CHUNK		m_bones;
	PMD_IK_CHUNK		m_ikbones;
	PMD_MORP_CHUNK		m_morps;
	PMD_CTRL_CHUNK		m_ctrls;
	PMD_GRP_NAME_CHUNK  m_grp_name;
	PMD_GRP_CHUNK		m_grp;

};
